unit UMyDialog5;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, MPlayer;

type
  TFormDialog = class(TForm)
    Label1: TLabel;
    OKButton: TButton;
    CancelButton: TButton;
    MediaPlayer1: TMediaPlayer;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OKButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  FormDialog: TFormDialog;  //  _CAO{bNXptH[

procedure SetChime;     //  `Cp*.wav̐ݒ

//   񂓂̕\
function  CheckMsg( s : string ) : Longint; overload;

//   ĂяõtH[̍ĕ`@\t
function  CheckMsg( s : string;
                    c : TComponent ) : Longint; overload;


implementation

{$R *.DFM}

var
  ck : Boolean;         //  {^̃NbÑ`FbNpϐ
  ID : Longint;         //  _CAO{bNX̏Iԃ`FbNpϐ
  NmWavFile : string;   //  *.wavt@Cݒpϐ

var
  stWav : Boolean = false;   //  `C̗L`FbNpϐ
                             //  false ==> ;  true ==> L

//  _CAO{bNXƂɎs
procedure TFormDialog.FormClose(Sender: TObject; var Action: TCloseAction);
begin
            ID:=-9;   ck:=true;    //    nj{^ACancel{^̃NbN
end;                               //  ȊȎŏIƂɗLɂȂ

//  nj{^̃NbNŎs
procedure TFormDialog.OKButtonClick(Sender: TObject);
begin
            ID:=0;    ck:=true;
end;

//  Cancel{^̃NbNŎs
procedure TFormDialog.CancelButtonClick(Sender: TObject);
begin
            ID:=1;    ck:=true;
end;

//  _CAO{bNX\̃`C̑I
//         *.wavŉw肷
procedure SetChime;
  var  OpenDialog : TOpenDialog;
  begin
      //  t@Cݒp_CAO{bNX̐
      OpenDialog:=TOpenDialog.Create(Application);

      try
        with OpenDialog do
          begin
            //   *.wavt@Ĉ݂\
            Filter := 'Wav files (*.wav)|*.wav';

            //  _CAO{bNX㕔̃^Cg̐ݒ
            Title:='CheckMsgp*.wavt@Cw肵ĉ';

            //  _CAO{bNX̕\
            if Execute
              then       //  t@C̐ݒ肪sꂽƂ
                begin    //  ϐNmWavFileɃt@Cݒ
                  NmWavFile:=FileName;
                  if Length(NmWavFile) > 3
                       then stWav:=true;   //  ϐstWavtrueɐݒ肵
                end;                       //  t@Cݒ肳ꂽƂ
          end;                             //  
        finally
          OpenDialog.Free;   //  _CAO{bNX̔p
      end;
  end;

//  _CAO{bNXptH[̐ݒE\
procedure SetForm( s : string );
  var
    LW : Longint;
  begin
    with FormDialog do
      begin
          //  MediaPlayerR|[lg̔\
          MediaPlayer1.Visible:=false;

          //  _CAO{bNXʒɒu
          position:=poScreenCenter;

          //  񂓂xLabel1ɕ\
          Label1.Caption:=s;

          //  xLabel1ɐݒ肳ꂽ񂓂
          //  Ƃ̓_CAO{bNX
          //  𒲐
          LW:=Label1.Left;
          if  ClientWidth-(Label1.Left+Label1.Width) < LW
            then
              begin
                ClientWidth:=Label1.Width+2*LW;
                position:=poScreenCenter;
              end;

          //   _CAO{bNX̕\
          Visible:=true;
          UpDate;
      end;
  end;

//  {^̃NbN҂
procedure WaitClick;
  begin
      with FormDialog do
        begin
            if stWav then    //  stWavtruêƂɃ`C炷
              with MediaPlayer1 do
                begin
                    //  *.wavt@C̐ݒ
                    FileName:=NmWavFile;

                    //  foCX^Cv*.wavt@Cpɐݒ
                   { DeviceType:=dtWaveAudio;  }
                    DeviceType:=dtAutoSelect;   //  Delphi 5 pɕύX 

                    //  MediaPlayer̃I[v
                    Open;

                    //  `CI܂Ŏɐi܂Ȃ悤ɐݒ
                    Wait:=true;

                    //  `C炷
                    Play;

                    //  MediaPlayer̃N[Y
                    Close;
                end;

            OKButton.SetFocus; UpDate;
        end;

      //     cktrueɂȂ܂ő҂
      repeat
        Application.ProcessMessages; //  NbNȂǂ̃`FbN
      until ck;
  end;


function  CheckMsg( s : string ) : Longint;
  begin
    Result:=-1;          //  ftHg̊֐l
    ck:=false;           //  NbNȂǂ̃`FbNp
    ID:=-1;              //  _CAO{bNX̏IԂ̃ftHgl

    //  ApplicationeƂă_CAO{bNX𐶐
    FormDialog:=TFormDialog.Create(Application);
    with FormDialog do
      begin
          SetForm(s);    //  tH[̕\
          WaitClick;     //  NbN҂
          Result:=ID;    //  IԂ֐lƂ
          Close;         //  _CAO{bNX
      end;
  end;

//   eƂă_CAO{bNX𐶐
function  CheckMsg( s : string;
                    c : TComponent ) : Longint;
  begin
    Result:=-1;
    ck:=false;
    ID:=-1;

    //  eƂă_CAO{bNX𐶐
    FormDialog:=TFormDialog.Create(c);
    with FormDialog do
      begin
          SetForm(s);

          //  etH[̉ʂ̃Abvf[g
          with c as TForm do UpDate;

          WaitClick;
          Result:=ID;
          Close;
      end;
  end;

end.
