unit UMyDialogEdit5;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, MPlayer;

type
  TFormDialogEdit = class(TForm)
    Label1: TLabel;
    OKButton: TButton;
    CancelButton: TButton;
    MediaPlayer1: TMediaPlayer;
    Edit1: TEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OKButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  FormDialogEdit: TFormDialogEdit;  //  _CAO{bNXptH[


procedure SetChimeGM;           //  `Cp*.wavt@C̐ݒ

//  Lxɕ\AGfBbgɐݒ肳ꂽ֐lƂ
function  GetMsg( L : string ) : string; overload;

//  ĂяõtH[̍ĕ`@\t
function  GetMsg( L : string;
                  c : TComponent ) : string; overload;

//  IR[hicodet
function  GetMsg( L : string;
                  var icode : Longint ) : string; overload;

//  ĂяõtH[̍ĕ`@\AIR[hicodet
function  GetMsg( L : string;
                  var icode : Longint;
                  c : TComponent ) : string; overload;

//  IR[h֐lƂ
function  GetMsgIC( L : string;
                    var msg : string ) : Longint; overload;

//  ĂяõtH[̍ĕ`@\t
function  GetMsgIC( L : string;
                    var msg : string;
                    c : TComponent ) : Longint; overload;

implementation

{$R *.DFM}

var
  ck : Boolean;          //  NbÑ`FbNpϐ
  ID : Longint;          //  tH[̏IԂ\킷ϐ
  vmsg : string;         //  ͕ƂĕԂlݒ肷ϐ
  NmWavFile : string;    //  `Cp*.wavt@Cݒpϐ

var
  stWav : Boolean = false;  //  \̃`C̗L\킷ϐ
  
//    _CAO{bNXptH[̏IɎs
procedure TFormDialogEdit.FormClose(Sender: TObject; var Action: TCloseAction);
begin
            ID:=-9;    //  OK{^ACancel{^̃NbNȊOł̏I
            ck:=true;
end;

//  OK{^̃NbNŎs
procedure TFormDialogEdit.OKButtonClick(Sender: TObject);
begin
            vmsg:=Edit1.Text;  //  Edit1̕ݒ
            ID:=0;             //  OK{^̃NbN\킷
            ck:=true;          //  NbN̐N\킷
end;

//  Cancel{^̃NbNŎs
procedure TFormDialogEdit.CancelButtonClick(Sender: TObject);
begin
            ID:=1;          //  Cancel{^̃NbN\킷
            ck:=true;
end;

//  `Cp*.wavt@C̐ݒ
procedure SetChimeGM;
  var  OpenDialog : TOpenDialog;
  begin
      OpenDialog:=TOpenDialog.Create(Application);
      try
        with OpenDialog do
          begin
            Filter := 'Wav files (*.wav)|*.wav';
            Title:='GetMsgp*.wavt@Cw肵ĉ';
            if Execute then
              begin
                NmWavFile:=FileName;
                if Length(NmWavFile) > 3
                     then stWav:=true;
              end;
          end;
        finally
          OpenDialog.Free;
      end;
  end;

//   _CAO{bNXptH[̐ݒ
procedure SetForm( L : string );
  begin
    with FormDialogEdit do
      begin
          MediaPlayer1.Visible:=false;
          position:=poScreenCenter;
          Visible:=true;
          Label1.Caption:=L;
          Edit1.Text:=vmsg;
          UpDate;
      end;
  end;

//  NbN҂
procedure WaitClick;
  begin
      with FormDialogEdit do
        begin
            if stWav then
              with MediaPlayer1 do
                begin
                    FileName:=NmWavFile;
                  {  DeviceType:=dtWaveAudio;  }

                    DeviceType:=dtAutoSelect;  //  Delphi 5 pɕύX
                    Open;
                    Wait:=true;
                    Play;
                    Close;
                end;
        end;

      repeat
        Application.ProcessMessages;
      until ck;
  end;

//   Edit1R|[lgɐݒ肳ꂽ֐lƂ
function  GetMsg( L : string ) : string;
  begin
    Result:='';     //  ֐l̃fBtHgl
    vmsg:='';       //  ݒ蕶̃fBtHgl
    ck:=false;
    FormDialogEdit:=TFormDialogEdit.Create(Application);
    with FormDialogEdit do
      begin
          SetForm(L);
          WaitClick;
          Result:=vmsg;  //  ϐvmsg̒l֐lƂ
          Close;
      end;
  end;

//  eƂă_CAO{bNX𐶐
function  GetMsg( L : string;
                  c : TComponent ) : string;
  begin
    Result:='';
    vmsg:='';
    ck:=false;
    FormDialogEdit:=TFormDialogEdit.Create(c);
    with FormDialogEdit do
      begin
          SetForm(L);

          with c as TForm do UpDate;

          WaitClick;
          Result:=vmsg;
          Close;
      end;
  end;

//   IR[hicodet
function  GetMsg( L : string;
                  var icode : Longint ) : string;
  begin
    Result:='';
    vmsg:='';
    ck:=false;
    icode:=-1;     //  R[h̃fBtHgliȏI\킷j
    ID:=-1;        //  _CAO{bNX̏IԂ̃fBtHgl
    FormDialogEdit:=TFormDialogEdit.Create(Application);
    with FormDialogEdit do
      begin
          SetForm(L);
          WaitClick;
          icode:=ID;      //  ID̒lIR[hƂ
          Result:=vmsg;
          Close;
      end;
  end;

//  IR[hicodetAeƂă_CAO{bNX𐶐
function  GetMsg( L : string;
                  var icode : Longint;
                  c : TComponent ) : string;
  begin
    Result:='';
    vmsg:='';
    ck:=false;
    icode:=-1;
    ID:=-1;
    FormDialogEdit:=TFormDialogEdit.Create(c);
    with FormDialogEdit do
      begin
          SetForm(L);

          with c as TForm do UpDate;

          WaitClick;
          icode:=ID;
          Result:=vmsg;
          Close;
      end;
  end;

//   IR[h֐lƂ
function  GetMsgIC( L : string;
                    var msg : string ) : Longint;
  begin
    vmsg:='';
    ck:=false;
    Result:=-1;
    ID:=-1;
    FormDialogEdit:=TFormDialogEdit.Create(Application);
    with FormDialogEdit do
      begin
          SetForm(L);
          WaitClick;
          Result:=ID;
          msg:=vmsg;
          Close;
      end;
  end;


function  GetMsgIC( L : string;
                    var msg : string;
                    c : TComponent ) : Longint; 
  begin
    vmsg:='';
    ck:=false;
    Result:=-1;
    ID:=-1;
    FormDialogEdit:=TFormDialogEdit.Create(c);
    with FormDialogEdit do
      begin
          SetForm(L);

          with c as TForm do UpDate;

          WaitClick;
          Result:=ID;
          msg:=vmsg;
          Close;
      end;
  end;

end.
